%define DATE 20031023
%define gcc_version 3.3.2
%define gcc_release 1
%define _unpackaged_files_terminate_build 0
%define multilib_64_archs sparc64 ppc64 s390x x86_64
%ifarch %{ix86} alpha ia64 ppc x86_64 s390
%define build_ada 1
%else
%define build_ada 0
%endif
%define build_java 1
%ifarch s390x
%define multilib_32_arch s390
%endif
%ifarch sparc64
%define multilib_32_arch sparc
%endif
%ifarch ppc64
%define multilib_32_arch ppc
%endif
%ifarch x86_64
%define multilib_32_arch i386
%endif
Summary: Various compilers (C, C++, Objective-C, Java, ...)
Name: gcc
Version: %{gcc_version}
Release: %{gcc_release}
Copyright: GPL
Group: Development/Languages
Source0: gcc-%{version}-%{DATE}.tar.bz2
Source1: libgcc_post_upgrade.c
URL: http://gcc.gnu.org
BuildRoot: /var/tmp/gcc-root
# Need binutils with -pie support
BuildRequires: binutils >= 2.14.90.0.4-4
BuildRequires: zlib-devel, gettext, dejagnu, bison, flex
# Make sure pthread.h doesn't contain __thread tokens
BuildRequires: glibc-devel >= 2.2.90-12
%if %{build_ada}
# Ada requires Ada to build
BuildRequires: gcc-gnat >= 3.1, libgnat >= 3.1
%endif
Requires: cpp = %{version}-%{release}
# Need .eh_frame ld optimizations
# Need proper visibility support
# Need -pie support
Requires: binutils >= 2.14.90.0.4-4
# Make sure gdb will understand DW_FORM_strp
Conflicts: gdb < 5.1-2
Requires: glibc-devel >= 2.2.90-12
Requires: libgcc >= %{version}-%{release}
Obsoletes: gcc3
Obsoletes: egcs
%ifarch sparc sparc64
Obsoletes: egcs64
%endif
Prereq: /sbin/install-info
AutoReq: true

Patch1: gcc33-multi32-hack.patch
Patch2: gcc33-ice-hack.patch
Patch3: gcc33-ppc64-m32-m64-multilib-only.patch
Patch4: gcc33-sched-ebb-cselib.patch

%define _gnu %{nil}
%ifarch sparc
%define gcc_target_platform sparc64-%{_vendor}-%{_target_os}
%endif
%ifarch ppc
%define gcc_target_platform ppc64-%{_vendor}-%{_target_os}
%endif
%ifnarch sparc ppc
%define gcc_target_platform %{_target_platform}
%endif

%description
The gcc package contains the GNU Compiler Collection version 3.3.2.
You'll need this package in order to compile C code.

%package -n libgcc
Summary: GCC version 3.3 shared support library
Group: System Environment/Libraries
Autoreq: false

%description -n libgcc
This package contains GCC shared support library which is needed
e.g. for exception handling support.

%package c++
Summary: C++ support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libstdc++ = %{version}
Requires: libstdc++-devel = %{version}
Obsoletes: gcc3-c++
Autoreq: true

%description c++
This package adds C++ support to the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++
Summary: GNU Standard C++ Library
Group: System Environment/Libraries
Obsoletes: libstdc++3
Autoreq: true

%description -n libstdc++
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdc++-devel
Summary: Header files and libraries for C++ development
Group: Development/Libraries
Requires: libstdc++ = %{version}-%{release}
Obsoletes: libstdc++3-devel
Autoreq: true

%description -n libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package objc
Summary: Objective-C support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libobjc = %{version}-%{release}
Obsoletes: gcc3-objc
Autoreq: true

%description objc
gcc-objc provides Objective-C support for the GCC.
Mainly used on systems running NeXTSTEP, Objective-C is an
object-oriented derivative of the C language.

%package -n libobjc
Summary: Objective-C runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libobjc
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%package g77
Summary: Fortran 77 support
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libf2c = %{version}-%{release}
Prereq: /sbin/install-info
Obsoletes: gcc3-g77
Autoreq: true

%description g77
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU Compiler Collection.

%package -n libf2c
Summary: Fortran 77 runtime
Group: System Environment/Libraries
Autoreq: true

%description -n libf2c
This package contains Fortran 77 shared library which is needed to run
Fortran 77 dynamically linked programs.

%package java
Summary: Java support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}
Requires: libgcj >= %{version}, libgcj-devel >= %{version}, zlib-devel
Obsoletes: gcc3-java
Prereq: /sbin/install-info
Autoreq: true

%description java
This package adds support for compiling Java(tm) programs and
bytecode into native code.

%package -n libgcj
Summary: Java runtime library for gcc
Group: System Environment/Libraries
Requires: zip >= 2.1
Obsoletes: gcc-libgcj
Obsoletes: libgcj3
# Kaffe includes jar too
Conflicts: kaffe
Autoreq: true

%description -n libgcj
The Java(tm) runtime library. You will need this package to run your Java
programs compiled using the Java compiler from GNU Compiler Collection (gcj).

%package -n libgcj-devel
Summary: Libraries for Java development using GCC
Group: Development/Languages
Requires: zip >= 2.1, libgcj = %{version}
Obsoletes: libgcj3-devel
Autoreq: true

%description -n libgcj-devel
The Java(tm) static libraries and C header files. You will need this
package to compile your Java programs using the GCC Java compiler (gcj).

%package sparc32
Summary: The C compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
Autoreq: true

%description sparc32
This package contains the GNU C compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-sparc32
Summary: The C++ compiler optimized for generating SPARC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-sparc32 = %{version}-%{release}
Requires: %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
Autoreq: true

%description c++-sparc32
This package contains the GNU C++ compiler which only supports generating
32bit SPARC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package ppc32
Summary: The C compiler optimized for generating PowerPC 32bit code
Group: Development/Languages
Requires: gcc = %{version}-%{release}, %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
Autoreq: true

%description ppc32
This package contains the GNU C compiler which only supports generating
32bit PowerPC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package c++-ppc32
Summary: The C++ compiler optimized for generating PowerPC 32bit code
Group: Development/Languages
Requires: gcc-c++ = %{version}-%{release}, gcc-ppc32 = %{version}-%{release}
Requires: %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
Autoreq: true

%description c++-ppc32
This package contains the GNU C++ compiler which only supports generating
32bit PowerPC code, but should be faster than the 32/64bit gcc package. You
should install this package if you want to trade disk space required for
this package for faster compilation of 32bit code.

%package -n cpp
Summary: The C Preprocessor.
Group: Development/Languages
Prereq: /sbin/install-info
%ifarch ia64
Obsoletes: gnupro
%endif
Autoreq: true

%description -n cpp
Cpp is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%package gnat
Summary: Ada 95 support for GCC
Group: Development/Languages
Requires: gcc = %{version}-%{release}, libgnat = %{version}-%{release}
Obsoletes: gnat-devel, gcc3-gnat
Prereq: /sbin/install-info
Autoreq: true

%description gnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes development tools,
the documents and Ada 95 compiler.

%package -n libgnat
Summary: GNU Ada 95 runtime shared libraries
Group: System Environment/Libraries
Obsoletes: gnat libgnat3
Autoreq: true

%description -n libgnat
GNAT is a GNU Ada 95 front-end to GCC. This package includes shared libraries,
which are required to run programs compiled with the GNAT.

%prep
%setup -q -n gcc-%{version}-%{DATE}
%ifarch sparc ppc
%patch1 -p0 -b .multi32-hack~
%endif
%patch2 -p0 -b .ice-hack~
%patch3 -p0 -b .ppc64-m32-m64-multilib-only~
%patch4 -p0 -b .sched-ebb-cselib~

perl -pi -e 's/3\.3\.3/3.3.2/' gcc/version.c
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(Red Hat Linux %{version}-%{gcc_release}\)/' gcc/version.c

# Misdesign in libstdc++
cp -a libstdc++-v3/config/cpu/i{4,3}86/atomicity.h

./contrib/gcc_update --touch

%build

rm -fr obj-%{gcc_target_platform}
mkdir obj-%{gcc_target_platform}
cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  mkdir locale
  localedef -f ISO-8859-1 -i de_DE locale/de_DE
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc sparc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch ppc ppc64
OPT_FLAGS=`echo $OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g'`
%endif
%ifarch sparc64
cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
chmod +x gcc64
CC=`pwd`/gcc64
%endif
%ifarch ppc64
if gcc -m64 -xc -S /dev/null -o - > /dev/null 2>&1; then
  cat > gcc64 <<"EOF"
#!/bin/sh
exec /usr/bin/gcc -m64 "$@"
EOF
  chmod +x gcc64
  CC=`pwd`/gcc64
fi
%endif
CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--enable-shared --enable-threads=posix --disable-checking \
	--with-system-zlib --enable-__cxa_atexit \
%if !%{build_ada}
	--enable-languages=c,c++,objc,java,f77 \
%endif
%if !%{build_java}
	--disable-libgcj \
%endif
%ifarch sparc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=v7
%endif
%ifarch ppc
	--host=%{gcc_target_platform} --build=%{gcc_target_platform} --target=%{gcc_target_platform} --with-cpu=default32
%endif
%ifnarch sparc ppc
	--host=%{gcc_target_platform}
%endif

make %{?_smp_mflags} bootstrap-lean
#make %{?_smp_mflags} bootstrap

%if %{build_ada}
# This doesn't work with -jN
make -C gcc gnatlib-shared
make -C gcc gnattools
%endif

# run the tests.
make %{?_smp_mflags} -k check || :
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi-verbose || :
echo ====================TESTING=========================
( ../contrib/test_summary || : ) 2>&1 | sed -n '/^cat.*EOF/,/^EOF/{/^cat.*EOF/d;/^EOF/d;/^LAST_UPDATED:/d;p;}'
make -C %{gcc_target_platform}/libstdc++-v3/testsuite -k check-abi || :
echo ====================TESTING END=====================
#cd %{gcc_target_platform}/libstdc++-v3
#./mkcheck 0
#cd ../..

# Make protoize
make -C gcc CC="./xgcc -B ./ -O2" proto

# Make c++filt
make -C %{gcc_target_platform}/libiberty CFLAGS="$RPM_OPT_FLAGS" c++filt

%ifarch sparc ppc
# Build the -m32 only compiler which does not use long long for HOST_WIDE_INT
mkdir gcc32
cd gcc32
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
echo "#!/bin/sh" > gcc32
echo "exec `cd ../gcc; pwd`/xgcc -B `cd ../gcc; pwd`/ $OPT_FLAGS \$*" >> gcc32
chmod +x gcc32
CC=`pwd`/gcc32 CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" \
  TCFLAGS="$OPT_FLAGS" ../../gcc/configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
  --enable-shared --enable-threads=posix --disable-checking \
  --with-system-zlib --enable-__cxa_atexit \
  --host=%{_target_platform}
make cc1 cc1plus
cd ..
%endif

# Make generated man pages even if Pod::Man is not new enough
perl -pi -e 's/head3/head2/' ../contrib/texi2pod.pl
for i in ../gcc/doc/*.texi; do
  cp -a $i $i.orig; sed 's/ftable/table/' $i.orig > $i
done
make -C gcc generated-manpages
for i in ../gcc/doc/*.texi; do mv -f $i.orig $i; done

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)

%install
rm -fr $RPM_BUILD_ROOT

perl -pi -e \
  's~href="l(ibstdc|atest)~href="http://gcc.gnu.org/onlinedocs/libstdc++/l\1~' \
  libstdc++-v3/docs/html/documentation.html
ln -sf documentation.html libstdc++-v3/docs/html/index.html
find libstdc++-v3/docs/html -name CVS | xargs rm -rf

cd obj-%{gcc_target_platform}

if [ ! -f /usr/lib/locale/de_DE/LC_CTYPE ]; then
  export LOCPATH=`pwd`/locale:/usr/lib/locale
fi

TARGET_PLATFORM=%{gcc_target_platform}

# There are some MP bugs in libstdc++ and libjava Makefiles
make -C %{gcc_target_platform}/libstdc++-v3
%if %{build_java}
make -C %{gcc_target_platform}/libjava
%endif

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} install
%if %{build_ada}
pushd ../gcc/ada
cp -a gnat-style.info* gnat_rm.info* $RPM_BUILD_ROOT%{_infodir}/
for i in gnat_ug_unx.info*; do
  sed 's/gnat_ug_unx/gnat_ug/g' $i > $RPM_BUILD_ROOT%{_infodir}/`echo $i | sed 's/gnat_ug_unx/gnat_ug/'`
done
chmod 644 $RPM_BUILD_ROOT%{_infodir}/gnat*
popd
%endif

FULLPATH=$RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}

cp -a %{gcc_target_platform}/libiberty/c++filt $RPM_BUILD_ROOT%{_prefix}/bin/c++filt
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c++filt

# fix some things
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/cc
mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ..%{_prefix}/bin/cpp $RPM_BUILD_ROOT/lib/cpp
ln -sf g77 $RPM_BUILD_ROOT%{_prefix}/bin/f77
rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/*.info*
ln -sf gcc $RPM_BUILD_ROOT%{_prefix}/bin/gnatgcc

%ifarch sparc ppc
# Install the sparc/ppc -m32 only compilers
FULLPATH32=$RPM_BUILD_ROOT%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
mkdir -p $FULLPATH32
install -m 755 gcc32/cc1 $FULLPATH32/
install -m 755 gcc32/cc1plus $FULLPATH32/
ln -sf ../../%{gcc_target_platform}/%{gcc_version}/include $FULLPATH32/
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc
ln -sf %{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
%endif
%ifarch ppc
mv $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{_target_platform}
ln -sf %{_target_platform} \
  $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{gcc_target_platform}
%endif
%ifarch sparc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
ln -f $RPM_BUILD_ROOT%{_prefix}/bin/%{gcc_target_platform}-gcc \
  $RPM_BUILD_ROOT%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif

%ifarch sparc ppc
FULLLPATH=$FULLPATH/lib32
%endif
%ifarch sparc64 ppc64
FULLLPATH=$FULLPATH/lib64
%endif
if [ -n "$FULLLPATH" ]; then
  mkdir -p $FULLLPATH
else
  FULLLPATH=$FULLPATH
fi

if [ "%{build_java}" -gt 0 ]; then
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcj.*a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/%{_lib}/lib-org-*.*a $FULLLPATH/
mv $RPM_BUILD_ROOT%{_prefix}/lib/libgcj.spec $FULLPATH/
#mv $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/
#mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu,org} $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu} $FULLPATH/include/
mkdir -p $FULLPATH/include/gcj
mv -f $RPM_BUILD_ROOT%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
rmdir $RPM_BUILD_ROOT%{_prefix}/include/gcj
fi

mkdir -p $RPM_BUILD_ROOT/%{_lib}
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgcc_s.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
chmod 755 $RPM_BUILD_ROOT/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
ln -sf libgcc_s-%{gcc_version}-%{DATE}.so.1 $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.1
ln -sf /%{_lib}/libgcc_s.so.1 $FULLPATH/libgcc_s.so
%ifarch sparc ppc
ln -sf /lib64/libgcc_s.so.1 $FULLPATH/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
ln -sf /lib/libgcc_s.so.1 $FULLPATH/libgcc_s_32.so
%endif

%if %{build_ada}
mv -f $FULLPATH/adalib/libgnarl-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
mv -f $FULLPATH/adalib/libgnat-*.so.* $RPM_BUILD_ROOT%{_prefix}/%{_lib}/
rm -f $FULLPATH/adalib/libgnarl.so* $FULLPATH/adalib/libgnat.so*
%endif

pushd $FULLPATH
if [ "%{_lib}" = "lib" ]; then
ln -sf ../../../libobjc.so.1 libobjc.so
ln -sf ../../../libstdc++.so.5.* libstdc++.so
%if %{build_java}
ln -sf ../../../libgcj.so.4.* libgcj.so
ln -sf ../../../lib-org-w3c-dom.so.0.* lib-org-w3c-dom.so
ln -sf ../../../lib-org-xml-sax.so.0.* lib-org-xml-sax.so
%endif
ln -sf ../../../libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../libgnarl-*.so.* libgnarl.so
ln -sf ../../../../libgnat-*.so.* libgnat.so
cd ..
%endif
else
ln -sf ../../../../%{_lib}/libobjc.so.1 libobjc.so
ln -sf ../../../../%{_lib}/libstdc++.so.5.* libstdc++.so
%if %{build_java}
ln -sf ../../../../%{_lib}/libgcj.so.4.* libgcj.so
ln -sf ../../../../%{_lib}/lib-org-w3c-dom.so.0.* lib-org-w3c-dom.so
ln -sf ../../../../%{_lib}/lib-org-xml-sax.so.0.* lib-org-xml-sax.so
%endif
ln -sf ../../../../%{_lib}/libg2c.so.0.* libg2c.so
%if %{build_ada}
cd adalib
ln -sf ../../../../../%{_lib}/libgnarl-*.so.* libgnarl.so
ln -sf ../../../../../%{_lib}/libgnat-*.so.* libgnat.so
cd ..
%endif
fi
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libstdc++.*a $FULLLPATH/
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libsupc++.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libfrtbegin.*a .
mv -f $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.*a .

%ifarch sparc ppc
ln -sf ../../../../../lib64/libobjc.so.1 64/libobjc.so
ln -sf ../`echo ../../../../lib/libstdc++.so.5.* | sed s~/lib/~/lib64/~` 64/libstdc++.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib/libgcj.so.4.* | sed s~/lib/~/lib64/~` 64/libgcj.so
ln -sf ../`echo ../../../../lib/lib-org-w3c-dom.so.0.* | sed s~/lib/~/lib64/~` 64/lib-org-w3c-dom.so
ln -sf ../`echo ../../../../lib/lib-org-xml-sax.so.0.* | sed s~/lib/~/lib64/~` 64/lib-org-xml-sax.so
fi
ln -sf ../`echo ../../../../lib/libg2c.so.0.* | sed s~/lib/~/lib64/~` 64/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libsupc++.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libg2c.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libfrtbegin.*a 64/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib64/libobjc.*a 64/
ln -sf lib32/libstdc++.a libstdc++.a
ln -sf ../lib64/libstdc++.a 64/libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf lib32/libgcj.a libgcj.a
ln -sf ../lib64/libgcj.a 64/libgcj.a
ln -sf lib32/lib-org-w3c-dom.a lib-org-w3c-dom.a
ln -sf ../lib64/lib-org-w3c-dom.a 64/lib-org-w3c-dom.a
ln -sf lib32/lib-org-xml-sax.a lib-org-xml-sax.a
ln -sf ../lib64/lib-org-xml-sax.a 64/lib-org-xml-sax.a
fi
%endif
%ifarch %{multilib_64_archs}
mkdir -p 32
ln -sf ../../../../libobjc.so.1 32/libobjc.so
ln -sf ../`echo ../../../../lib64/libstdc++.so.5.* | sed s~/../lib64/~/~` 32/libstdc++.so
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../`echo ../../../../lib64/libgcj.so.4.* | sed s~/../lib64/~/~` 32/libgcj.so
ln -sf ../`echo ../../../../lib64/lib-org-w3c-dom.so.0.* | sed s~/../lib64/~/~` 32/lib-org-w3c-dom.so
ln -sf ../`echo ../../../../lib64/lib-org-xml-sax.so.0.* | sed s~/../lib64/~/~` 32/lib-org-xml-sax.so
fi
ln -sf ../`echo ../../../../lib64/libg2c.so.0.* | sed s~/../lib64/~/~` 32/libg2c.so
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libsupc++.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libg2c.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libfrtbegin.*a 32/
mv -f $RPM_BUILD_ROOT%{_prefix}/lib/libobjc.*a 32/
%endif
%ifarch sparc64 ppc64
ln -sf ../lib32/libstdc++.a 32/libstdc++.a
ln -sf lib64/libstdc++.a libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../lib32/libgcj.a 32/libgcj.a
ln -sf lib64/libgcj.a libgcj.a
ln -sf ../lib32/lib-org-w3c-dom.a 32/lib-org-w3c-dom.a
ln -sf lib64/lib-org-w3c-dom.a lib-org-w3c-dom.a
ln -sf ../lib32/lib-org-xml-sax.a 32/lib-org-xml-sax.a
ln -sf lib64/lib-org-xml-sax.a lib-org-xml-sax.a
fi
%else
%ifarch %{multilib_64_archs}
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libstdc++.a 32/libstdc++.a
if [ "%{build_java}" -gt 0 ]; then
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/libgcj.a 32/libgcj.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-org-w3c-dom.a 32/lib-org-w3c-dom.a
ln -sf ../../../%{multilib_32_arch}-%{_vendor}-%{_target_os}/%{gcc_version}/lib-org-xml-sax.a 32/lib-org-xml-sax.a
fi
%endif
%endif

# Strip debug info from Fortran/ObjC/Java static libraries
strip -g `find . \( -name libg2c.a -o -name libobjc.a -o -name libgcj.a \
		    -o -name lib-org-w3c-dom.a -o -name lib-org-xml-sax.a \
		    -o -name libgcc.a \) -a -type f`
popd
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libg2c.so.0.*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libobjc.so.1.*

%if %{build_ada}
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnarl*so*
chmod 755 $RPM_BUILD_ROOT%{_prefix}/%{_lib}/libgnat*so*
%endif

for h in `find $FULLPATH/include -name \*.h`; do
  if grep -q 'It has been auto-edited by fixincludes from' $h; then
    rh=`grep -A2 'It has been auto-edited by fixincludes from' $h | tail -1 | sed 's|^.*"\(.*\)".*$|\1|'`
    diff -up $rh $h || :
    rm -f $h
  fi
done

cat > $RPM_BUILD_ROOT%{_prefix}/bin/c89 <<"EOF"
#!/bin/sh
fl="-std=c89"
for opt; do
  case "$opt" in
    -ansi|-std=c89|-std=iso9899:1990) fl="";;
    -std=*) echo "`basename $0` called with non ANSI/ISO C option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
cat > $RPM_BUILD_ROOT%{_prefix}/bin/c99 <<"EOF"
#!/bin/sh
fl="-std=c99"
for opt; do
  case "$opt" in
    -std=c99|-std=iso9899:1999) fl="";;
    -std=*) echo "`basename $0` called with non ISO C99 option $opt" >&2
	    exit 1;;
  esac
done
exec %{_prefix}/bin/gcc $fl ${1+"$@"}
EOF
chmod 755 $RPM_BUILD_ROOT%{_prefix}/bin/c?9

mkdir -p $RPM_BUILD_ROOT%{_prefix}/sbin
gcc -static -Os %{SOURCE1} -o $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade
strip $RPM_BUILD_ROOT%{_prefix}/sbin/libgcc_post_upgrade

cd ..
%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcc.info.gz

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
fi

%post -n cpp
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/cpp.info.gz

%preun -n cpp
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
fi

%post g77
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/g77.info.gz

%preun g77
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/g77.info.gz
fi

%post java
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gcj.info.gz

%preun java
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
fi

%post gnat
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/gnat_ug.info.gz

%preun gnat
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/gnat_ug.info.gz
fi

# Because glibc Prereq's libgcc and /sbin/ldconfig
# comes from glibc, it might not exist yet when
# libgcc is installed
%post -n libgcc -p %{_prefix}/sbin/libgcc_post_upgrade

%post -n libstdc++ -p /sbin/ldconfig

%postun -n libstdc++ -p /sbin/ldconfig

%post -n libobjc -p /sbin/ldconfig

%postun -n libobjc -p /sbin/ldconfig

%post -n libgcj
/sbin/ldconfig
/sbin/install-info \
  --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz

%preun -n libgcj
if [ $1 = 0 ]; then
  /sbin/install-info --delete \
    --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
fi

%postun -n libgcj -p /sbin/ldconfig

%post -n libf2c -p /sbin/ldconfig

%postun -n libf2c -p /sbin/ldconfig

%post -n libgnat -p /sbin/ldconfig

%postun -n libgnat -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-,root,root)
%{_prefix}/bin/cc
%{_prefix}/bin/c89
%{_prefix}/bin/c99
%{_prefix}/bin/gcc
%{_prefix}/bin/gcov
%{_prefix}/bin/protoize
%{_prefix}/bin/unprotoize
%ifarch sparc ppc
%{_prefix}/bin/%{_target_platform}-gcc
%endif
%ifarch sparc64
%{_prefix}/bin/sparc-%{_vendor}-%{_target_os}-gcc
%endif
%ifarch ppc64
%{_prefix}/bin/ppc-%{_vendor}-%{_target_os}-gcc
%endif
%{_prefix}/bin/%{gcc_target_platform}-gcc
%{_mandir}/man1/gcc.1*
%{_mandir}/man1/gcov.1*
%{_infodir}/gcc*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stddef.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stdarg.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/varargs.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/float.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/limits.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/stdbool.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/iso646.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/syslimits.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/unwind.h
%ifarch %{ix86} x86_64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/mmintrin.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/xmmintrin.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/emmintrin.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/pmmintrin.h
%endif
%ifarch ia64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%ifarch ppc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/ppc-asm.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/altivec.h
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/README
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/collect2
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/crt*.o
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s.so
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/crt*.o
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s_64.so
%endif
%ifarch %{multilib_64_archs}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/crt*.o
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcc_eh.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcc_s_32.so
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog*

%files -n cpp
%defattr(-,root,root)
/lib/cpp
%{_prefix}/bin/cpp
%{_mandir}/man1/cpp.1*
%{_infodir}/cpp*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1

%files -n libgcc
%defattr(-,root,root)
/%{_lib}/libgcc_s-%{gcc_version}-%{DATE}.so.1
/%{_lib}/libgcc_s.so.1
%{_prefix}/sbin/libgcc_post_upgrade

%files c++
%defattr(-,root,root)
%{_prefix}/bin/%{gcc_target_platform}-*++
%{_prefix}/bin/g++
%{_prefix}/bin/c++
%{_prefix}/bin/c++filt
%{_mandir}/man1/g++.1*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1plus
%ifarch sparc ppc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libstdc++.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libsupc++.a
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libstdc++.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libsupc++.a
%endif
%ifarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%doc gcc/cp/ChangeLog*

%files -n libstdc++
%defattr(-,root,root)
%{_prefix}/%{_lib}/libstdc++.so.5*

%files -n libstdc++-devel
%defattr(-,root,root)
%{_prefix}/include/c++
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libstdc++.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libstdc++.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.a
%endif
%ifnarch sparc ppc %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libstdc++.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libsupc++.a
%endif
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README* libstdc++-v3/docs/html/

%files objc
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/objc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/cc1obj
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libobjc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libobjc.so
%ifarch sparc ppc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libobjc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libobjc.so
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libobjc.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libobjc.so
%endif
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

%files -n libobjc
%defattr(-,root,root)
%{_prefix}/%{_lib}/libobjc.so.1*

%files g77
%defattr(-,root,root)
%{_prefix}/bin/g77
%{_prefix}/bin/f77
%{_mandir}/man1/g77.1*
%{_infodir}/g77*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/f771
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libg2c.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libg2c.so
%ifarch sparc ppc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libg2c.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libg2c.so
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libfrtbegin.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libg2c.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libg2c.so
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/g2c.h
%doc gcc/f/README rpm.doc/g77/*

%files -n libf2c
%defattr(-,root,root)
%{_prefix}/%{_lib}/libg2c.so.0*

%if %{build_java}
%files java
%defattr(-,root,root)
%{_prefix}/bin/gcj
%{_prefix}/bin/gcjh
%{_prefix}/bin/jcf-dump
%{_prefix}/bin/jv-scan
%{_mandir}/man1/gcj.1*
%{_mandir}/man1/gcjh.1*
%{_mandir}/man1/jcf-dump.1*
%{_mandir}/man1/jv-scan.1*
%{_infodir}/gcj*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/jc1
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/jvgenmain
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.so
%ifarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.a
%endif
%ifarch sparc ppc
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcj.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/libgcj.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/lib-org-w3c-dom.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/lib-org-w3c-dom.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/lib-org-xml-sax.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/64/lib-org-xml-sax.a
%endif
%ifarch %{multilib_64_archs}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcj.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/libgcj.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/lib-org-w3c-dom.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/lib-org-w3c-dom.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/lib-org-xml-sax.so
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/32/lib-org-xml-sax.a
%endif
%doc gcc/java/ChangeLog*

%files -n libgcj
%defattr(-,root,root)
%{_prefix}/bin/jv-convert
%{_prefix}/bin/gij
%{_prefix}/bin/jar
%{_prefix}/bin/grepjar
%{_prefix}/bin/rmic
%{_prefix}/bin/rmiregistry
%{_mandir}/man1/jar.1*
%{_mandir}/man1/grepjar.1*
%{_mandir}/man1/jv-convert.1*
%{_mandir}/man1/gij.1*
%{_mandir}/man1/rmic.1*
%{_mandir}/man1/rmiregistry.1*
%{_infodir}/fastjar*
%{_prefix}/%{_lib}/libgcj.so.*
%{_prefix}/%{_lib}/lib-org-w3c-dom.so.*
%{_prefix}/%{_lib}/lib-org-xml-sax.so.*
%{_prefix}/share/java
%{_prefix}/lib/security

%files -n libgcj-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk
%ifarch sparc ppc
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/libgcj.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/lib-org-w3c-dom.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib32/lib-org-xml-sax.a
%endif
%ifarch sparc64 ppc64
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/libgcj.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/lib-org-w3c-dom.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib64/lib-org-xml-sax.a
%endif
%ifnarch sparc sparc64 ppc ppc64
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib-org-w3c-dom.a
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/lib-org-xml-sax.a
%endif
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/libgcj.spec
#%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gc*.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/j*.h
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/java
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/javax
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gnu
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/gcj
#%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/include/org
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*
%endif

%if %{build_ada}
%files gnat
%defattr(-,root,root)
%{_prefix}/bin/gnat*
%{_infodir}/gnat*
%dir %{_prefix}/lib/gcc-lib
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}
%dir %{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/adainclude
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/adalib
%{_prefix}/lib/gcc-lib/%{gcc_target_platform}/%{gcc_version}/gnat1
%doc gcc/ada/ChangeLog

%files -n libgnat
%defattr(-,root,root)
%{_prefix}/%{_lib}/libgnat-*.so.*
%{_prefix}/%{_lib}/libgnarl-*.so.*
%endif

%ifarch sparc
%files sparc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include

%files c++-sparc32
%defattr(-,root,root)
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%endif

%ifarch ppc
%files ppc32
%defattr(-,root,root)
%dir %{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/include

%files c++-ppc32
%defattr(-,root,root)
%{_prefix}/lib/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%endif

%changelog
* Thu Oct 23 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.2-1
- update from gcc-3_3-branch
  - 3.3.2 release
  - PRs debug/12500, c/11885, bootstrap/9330, target/11087,
	target/11949, optimization/12544, optimization/12510,
	bootstrap/12490, optimization/12215, optimization/11637,
	c/12446, 11883, optimization/12180, 12292, 12072,
	optimization/11753, c++/12369, c++/7939, c++/11878,
	c++/11063, c++/10147, c++/12337, c++/12344, c++/12236,
	c++/8656, c++/11409, c++/12486, libstdc++/10081, libstdc++/11740,
	libstdc++/12451
  - fix java signal handling (Ulrich Weigand)

* Thu Oct  2 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.1-6
- update from gcc-3_3-branch
  - PRs optimization/12340, bootstrap/12358, target/9786, target/12301,
	target/12166, target/11184, optimization/11646, c++/11991,
	c++/12266, libstdc++/12296, libstdc++/11400, libstdc++/11065
- fix invalid C++ tree sharing bug (Mark Mitchell, #105784)

* Tue Sep 16 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.1-5
- update from gcc-3_3-branch
  - PRs fortran/11522, target/11965, target/12224, target/11689,
	c++/11852, optimization/11662, target/12070, opt/12082,
	c/9862, target/8869, c/10962, c++/3907, c++/11595,
	c++/11786, c++/5296, c++/12181, c++/11867, c++/12163,
	c++/12146, libstdc++/12189
  - fix cpp -lang-asm bug (Alexandre Oliva)
- add __attribute__((warn_unused_result)) support
- use --start-group -lgcc -lgcc_eh -lc --end-group when doing
  static linking

* Sun Sep  7 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.1-4
- split insns right before regstack on IA-32 at -O1 (#102493)

* Fri Sep  5 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.1-3
- update from gcc-3_3-branch
  - PRs 10988, target/11805, c/11207, c++/12114, c++/11928,
	c++/5293
  - export _Unwind_GetBSP@@GCC_3.3.2 from libgcc_s.so on IA-64
  - fix linux kernel miscompilation with __builtin_expect (#102747)

* Sat Aug 16 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.1-2
- update from gcc-3_3-branch
  - PRs optimization/11319, target/10021
- SPARC TLS support
- fix libgcc_post_upgrade on sparc64
- fix a bug in finish_struct

* Tue Aug 12 2003 Jakub Jelinek  <jakub@redhat.com> 3.3.1-1
- update from gcc-3_3-branch
  - gcc 3.3.1 release
  - PRs target/11693, c++/11712, target/9877, target/8336,
	c/11370, 11709, preprocessor/11534, 10510, 11313,
	target/10681, c++/11713, libstdc++/11784, 
  - fix IA-64 __builtin_return_address (Richard Henderson, #99220,
    PR target/11535)
- speed up get_identifier with string literal argument (Roger Sayle)
- fix cross-jumping on s390 (#91185)

* Thu Jul 31 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-17
- fix an amd64 TLS pic bug
- remove libgcc's %%postun

* Tue Jul 29 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-16
- update from gcc-3_3-branch
  - PR c++/10796
- don't destroy argument to fold/convert/extract_muldiv (#98550)
- add -Wdeclaration-after-statement (Hans-Peter Nilsson)
- statically link /usr/sbin/libgcc_post_upgrade
- BuildRequire bison and flex (#98920)
- fix merge bug in store_by_pieces
- kill some warnings

* Fri Jul 25 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-15
- update from gcc-3_3-branch
  - PRs 8878, target/11607, target/11516, optimization/10679,
	optimization/11599, optimization/11536, debug/11279,
	optimization/4490, target/11556, optimization/11083,
	optimization/11557, bootstrap/11043, other/11466,
	target/10907, target/11087, c++/11513, c++/11645,
	c++/11282, c++/11546, libstdc++/11528
- add /usr/sbin/libgcc_post_upgrade, use it in libgcc's %%post
- turn off autorequires for libgcc

* Wed Jul 16 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-14
- update from gcc-3_3-branch
  - PRs debug/11473, optimization/11320, debug/11098, optimization/11440,
	optimization/11059, optimization/10877, c++/1607, c++/9738,
	c++/5287, c++/7910, c++/11021, optimization/9745, bootstrap/10758,
	c++/10032, target/11453, target/10021, c++/7053, c++/11154,
	c++/11503, c++/8164, c++/10558, c++/10032, c++/10527, c++/10849,
	c++/11236, libgcj/10886, libgcj/10838
  - export __gcc_personality_{v,sj}0 from libgcc_s
- fix ppc64 unwinding through signal frames
- don't access memory below 288 bytes under $r1 on ppc64
  in libgcc_eh.a
- fix string-opt-8.c testcase after strcmp/strncmp fix on s390
- fix ppc32 MD_FALLBACK_FRAME_STATE_FOR
- fix builtin strcmp and strncmp miscompilation on s390{,x}
- fix IA-64 bootstrap failure caused during schedule_ebbs

* Wed Jul  9 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-13
- update from gcc-3_3-branch
  - fix amd64 -fpic with volatile variable (#98518, c/11420)
  - fix strength reduction causing miscompilation of pwlib on s390x
  - PRs 10900, optimization/11368, optimization/11198, optimization/11304,
	target/10700, optimization/11381, 2873, target/11014,
	optimization/11054, bootstrap/3163, other/11280, target/11084,
	target/11260, c++/11345, c++/11431, c++/6949, c++/11137,
	c++/11149, c++/9559, c++/11106, c++/10468, c++/10796,
	c++/11332, c++/10990, c++/10931, c++/5754
- move cc1 to cpp package, so that cpp can work even when gcc
  and devel packages aren't installed
- Intel Prescott support (H.J.Lu)
- optimize builtin sprintf (Roger Sayle)

* Tue Jun 24 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-12
- update from gcc-3_3-branch
  - new libstdc++ abilist files
- update check-abi logic in the spec file

* Mon Jun 23 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-11
- update from gcc-3_3-branch
  - PRs c++/9393, c++/10888, driver/9362, preprocessor/11022,
	c++/10784, c++/10864, c++/10915, c++/10845, c++/10939,
	c++/9649, c++/11041, c++/11228, bootstrap/11272
- fix GC problems introduced in c++/11105 fix
- fix a bug in builtin strcpy evaluation
- optimize more cases of builtin strlen, str*cmp, strcpy, strncpy,
  fputs

* Mon Jun 23 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-10
- fix cc1plus segfault when a mangling hashtable was expanded
  for the first time (introduced in c++/11105 fix)

* Sun Jun 22 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-9
- fix -fpic virtual thunks on amd64
- fix g++.dg/init/new6.C regression introduced in 3.3-8

* Sat Jun 21 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-8
- update from gcc-3_3-branch
  - PRs c++/10929, c++/10712, c++/11105
  - _Unwind_GetCFA and _Unwind_FindEnclosingFunction implemented
    in ia64 libgcc_s.so
- ppc32 libffi fixes (Franz Sirl)
- don't warn about #pragma once if -Wno-deprecated (Jason Merrill, #97723)
- fix s390 thunks, call a local alias of method instead of the exported
  symbols in thunks if assembler supports .set
- fix a bug in gcc driver hack for ICE analysis which caused
  some reproduceable bugs printed as non-reproduceable

* Mon Jun 16 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-7
- update from gcc-3_3-branch
  - PRs target/8787, inline-asm/4823, target/7594, middle-end/10475,
	optimization/10955, target/10142, middle-end/10557, target/11183,
	optimization/10842, c++/10635, debug/9864
  - use la instead of ar on s390 to initialize got register
- change asm name of some further implicitely generated builtins
  when using __asm on the builtin function

* Wed Jun 11 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-6
- update from gcc-3_3-branch
  - PRs inline-asm/10890, target/11052, target/10331, target/11096,
	target/10663, c++/10968, 8861, c++/11039, c++/10940,
	libstdc++/11095
  - define __EXCEPTIONS in C if -fexceptions
- fix warning about frontend unsupported switches (#97165)
- fix filename printed in -Winline called from here warning
- don't build -msoft-float multilibs on ppc* even in -m32
- install unwind.h

* Thu Jun  5 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-5
- update from gcc-3_3-branch
  - PRs optimization/11018, optimization/10876, target/10673
  - __attribute__((cleanup)) (Richard Henderson)
- add a gcc driver hack to check reproduceability of ICEs
  and create preproccessed testcase if they are reproduceable
- make sure libgcc.a objects have non-exec .note.GNU-stack
- fix ppc64 build

* Wed Jun  4 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-4
- mark object files with .note.GNU-stack notes whether they
  need or don't need executable stack

* Tue Jun  3 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-3
- update from gcc-3_3-branch
  - PRs target/11044, 10871, bootstrap/10805, c/10355, ada/6399,
	c++/10956, c++/10849, c++/10682, libstdc++/9815, libstdc++/11062,
	libstdc++/10689
- position independent executable support (-pie/-fpie/-fPIE)
- better optimize builtin mempcpy and stpcpy

* Tue May 20 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-2
- update from gcc-3_3-branch
  - name lookup improvements
  - PRs c++/10661, c++/5388
- ppc TLS, bi-arch plus 2 other patches

* Sat May 17 2003 Jakub Jelinek  <jakub@redhat.com> 3.3-1
- new rpm
